<?php

/**
 * Element Controls
 */

//print_r($wp);




return array(



    'skin' => array(
        'type' => 'dropdown',
        'ui' => array(
            'title' => __( 'Skin', 'dzsprg' ),
            'tooltip' => __( 'Choose to display the heading vertically or horizonatally', 'dzsprg' ),
        ),

        'options' => array(
            'choices' => $dzsprg->arr_skins_for_cs,
        ),
        'context' => 'content',

    ),




    'arg1_perc' => array(
        'type' => 'text',
        'ui' => array(
            'title' => __( 'Percent', 'dzsprg' ),
            'tooltip' => __( 'The percent on which the progress bar goes. A value from 0 to 100.', 'dzsprg' ),
        ),

        'context' => 'content',
        'suggest' => 80,
    ),

    'arg2_maxnr' => array(
        'type' => 'text',
        'ui' => array(
            'title' => __( 'Percent Number', 'dzsprg' ),
            'tooltip' => __( 'A number that can be increased based on percent. Can be any number.', 'dzsprg' ),
        ),

        'context' => 'content',
        'suggest' => 80,
    ),



    'content' => array(
        'type' => 'text',
        'ui' => array(
            'title' => __( 'Text', 'dzsprg' ),
            'tooltip' => __( 'Enter your text for skins that receive a text parameter.', 'dzsprg' ),
        ),

        'context' => 'content',
        'suggest' => __("<p>I am test text block. Click edit button to change this text.</p>"),
    ),



    'arg4' => array(
        'type' => 'text',
        'ui' => array(
            'title' => sprintf(__("Argument %s",'dzsprg'),'4'),
            'tooltip' => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it"),
        ),

        'context' => 'content',
        'suggest' => '',
    ),


    'arg5' => array(
        'type' => 'text',
        'ui' => array(
            'title' => sprintf(__("Argument %s",'dzsprg'),'5'),
            'tooltip' => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it"),
        ),

        'context' => 'content',
        'suggest' => '',
    ),


    'arg6' => array(
        'type' => 'text',
        'ui' => array(
            'title' => sprintf(__("Argument %s",'dzsprg'),'6'),
            'tooltip' => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it"),
        ),

        'context' => 'content',
        'suggest' => '',
    ),


    'arg7' => array(
        'type' => 'text',
        'ui' => array(
            'title' => sprintf(__("Argument %s",'dzsprg'),'7'),
            'tooltip' => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it"),
        ),

        'context' => 'content',
        'suggest' => '',
    ),


    'arg8' => array(
        'type' => 'text',
        'ui' => array(
            'title' => sprintf(__("Argument %s",'dzsprg'),'8'),
            'tooltip' => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it"),
        ),

        'context' => 'content',
        'suggest' => '',
    ),


    'arg9' => array(
        'type' => 'text',
        'ui' => array(
            'title' => sprintf(__("Argument %s",'dzsprg'),'9'),
            'tooltip' => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it"),
        ),

        'context' => 'content',
        'suggest' => '',
    ),






);
