jQuery(document).ready(function ($) {


  var inter_update_preview = 0;


  var includemediasupport = '';
  var tinymce_external_plugins = {};

  var builder_all_settings_inited = false;

  var initial_cache_offset_top = -1;

  var _feedbacker = $('.saveconfirmer').eq(0);

  if (includemediasupport == ',filemanager') {
    tinymce_external_plugins = {"filemanager": dzsprg_builder_settings.thepath + 'filemanager/plugin.min.js'};
  }

  //return false;
  function textarea_to_tinymce(id) {

    //console.info('tinyMCE - ',tinyMCE, $('#'+id));
    if (typeof (tinyMCE) == "object" && typeof (tinyMCE.execCommand) == "function") {
      tinyMCE.execCommand("mceAddEditor", false, id);
      tinyMCE.execCommand('mceAddControl', false, id);
    }
  }

  //textarea_to_tinymce("text_container");


  if(tinyMCE){

    console.log('dzsprg_builder_settings - ', dzsprg_builder_settings);
    tinyMCE.baseURL = dzsprg_builder_settings.base_url+'tinymce/tinymce/';
  }
  var tinymce_settings = {
    script_url: dzsprg_builder_settings.base_url + 'tinymce/tinymce/tinymce.min.js',
    mode: "textareas",
    theme: "modern",
    plugins: "hr fullscreen code noneditable fontawesome",
    relative_urls: false
    ,
    remove_script_host: false
    ,
    image_advtab: true
    ,
    convert_urls: true,
    noneditable_noneditable_class: ''
    ,
    forced_root_block: ""
    ,
    menubar: false
    ,
    extended_valid_elements: 'span[*],a[*],i[*]'
    ,
    content_css: 'https://netdna.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css',
    theme_advanced_toolbar_location: "top"
    //,theme_advanced_toolbar_align : "left"
    //,theme_advanced_statusbar_location : "bottom"
    ,
    toolbar: "bold italic | alignleft aligncenter alignright  | bullist numlist | link image | removeformat code fontawesome"


  };




  if (window.override_tinymce_settings) {
    tinymce_settings = $.extend({}, window.override_tinymce_settings);
  }

  console.info('tinymce_settings - ', tinymce_settings);

  var _areaCanvas = $('.dzsprg-builder-con--canvas-area').eq(0);
  var _areaLayers = $('.dzsprg-builder-con--layers-area').eq(0);


  dzsscr_init('.scroller-con');


  _areaLayers.children('.dd').nestable({
    'maxDepth': 2
    , action_drag_start: function (_arg, _argItem) {
      _argItem.find('.with-tinymce.activated').removeClass('activated').tinymce().remove();

    }
    , action_drag_stop: function () {
      arrange_layers();
      update_fields({
        'call_from': 'stop_sortable'
      });
    }
  });

  $('.saveconfirmer').removeClass('active');
//    _areaLayers.disableSelection();


//    console.info($('input[name="bars[mainsettings][maxperc]"]').eq(0).val());
  $(".jqueryui-slider.for-perc").slider({
    range: "max",
    min: 1,
    max: 100,
    value: $('input[name="bars[mainsettings][maxperc]"]').eq(0).val(),
    slide: function (e, ui) {
//            $( "#amount" ).val( ui.value );
      var _t = $(this);
      var _par = _t.parent();
      _par.find('input').eq(0).val(ui.value);
      _par.find('input').eq(0).trigger('change');
    }
  });

  $('.builder-add-rect').bind('click', click_add_btn);
  $('.builder-add-text').bind('click', click_add_btn);
  $('.builder-add-circ,.builder-add-container,.builder-add-repeater').bind('click', click_add_btn);
  $('input[name="builder_skin_name"]').bind('change', change_skin_name);
  $('.btn-show-select').bind('click', click_show_select);
  $('.btn-save-skin').bind('click', click_save_skin);
  $('.btn-preview').bind('click', function () {

    arrange_layers();
    update_fields({
      'call_from': 'preview_it'
    });
  });


  $(document).on('mouseover', '.builder-layer', handle_mouse);
  $(document).on('mouseleave', '.builder-layer', handle_mouse);
  $(document).on('click', '.builder-layer--head', click_layer_head);
  $(document).on('click', '.dzs-button-on-off,.delete-skin-btn,.btn-insert-icon,.btn-skin-settings', handle_mouse);
  $(window).on('scroll', handle_scroll);

  $(document).delegate('.builder-field', 'change', change_builder_field);
  $(document).delegate('.builder-layer--btn-delete', 'click', click_layer_delete);
  $(document).delegate('.dzsprg-builder-con--canvas-area > *', 'click', click_layer_in_canvas);


  tinymce_settings.setup = function (ed) {
    ed.on('change', function (e) {
      update_fields({
        'call_from': 'change_tinymce'
      });
    });
  }


  var _c = _areaLayers.children().find('textarea.with-tinymce');
  _c.each(function () {
    var _t = $(this);
    if (_t.hasClass('activated') == false) {
      if ($.fn.tinymce) {
        _t.addClass('activated').tinymce(tinymce_settings);
      }
    }
  })


  $('#tabs-mainsettings').dzstabsandaccordions({
    'design_tabsposition': 'top'
    , design_transition: 'fade'
    , design_tabswidth: 'fullwidth'
    , toggle_breakpoint: '300'
    // ,toggle_type: 'toggle'
    , settings_appendWholeContent: true
  });
  init_dzstabsandaccordions();
  reskin_select();
  arrange_layers();

  setTimeout(function () {
    builder_all_settings_inited = true;
    update_fields({
      'call_from': 'firsttimeout'
    })
  }, 1000);


  function click_preview() {

    console.info('click_preview()', _areaCanvas.hasClass('inited'));

    _areaCanvas.find('.dzs-progress-bars').each(function () {

      var _t = $(this);

      console.info('destroying - ', _t);

      if (_t.get(0) && _t.get(0).api_destroy_listeners) {
        _t.get(0).api_destroy_listeners();
      }
    });

    if (builder_all_settings_inited) {

      if (_areaCanvas.hasClass('inited')) {
        _areaCanvas.css('height', $('input[name="bars[mainsettings][height]"]').eq(0).val());


        var ind = 0;
        _areaCanvas.find('.progress-bar-item--repeater').each(function () {
          var _t = $(this);
          var _c = _areaLayers.find('.dd-item.type-repeater').eq(ind);


          var _cs = _t.find('.repeater-item--sample').eq(0);

          _cs.find('.real-icon').eq(0).attr('class', 'real-icon fa');
          _cs.find('.real-icon').eq(0).addClass('fa-' + _c.find('*[data-label="item_icon"]').val());
          _cs.find('.real-icon').eq(0).css('padding', sanitize_dim_css(_c.find('*[data-label="repeater_padding"]').val()));
          _t.find('.repeater-item--sample').show();


          // console.info(_c);

          ind++;
        })


        _areaCanvas.get(0).api_restart_and_reinit();
        //update_fields({
        //    'call_from':'change_builder_field'
        //});
      } else {
        // _areaCanvas.css('opacity',1);
        _areaCanvas.css('height', $('input[name="bars[mainsettings][height]"]').eq(0).val());

        var args = {
          'initon': 'init'
          , 'maxperc': $('input[name="bars[mainsettings][maxperc]"]').eq(0).val()
          , 'maxnr': $('input[name="bars[mainsettings][maxnr]"]').eq(0).val()
          , 'animation_time': $('input[name="bars[mainsettings][animation_time]"]').eq(0).val()
          , 'transition_text': $('select[name*="bars[mainsettings][transition_text]"]').eq(0).val()
        };

        console.warn('args - ', args);

        _areaCanvas.progressbars(args);
      }
    }
  }

  function click_layer_in_canvas() {
    var _t = $(this);
    var _par = _t.parent();
    var ind = _par.children().index(_t);


    var _c = $('.dd-item[data-index=' + _t.attr('data-index') + ']');


    _c.addClass('active');
    _c.addClass('just-activated');

    setTimeout(function () {

      _c.removeClass('just-activated');
    }, 500);


    if (_c && _c.offset()) {

      console.info('_c.offset().top - ', _c.offset().top);
      $('html,body').animate({
        scrollTop: _c.offset().top
      }, 300);
    }
  }


  function click_layer_delete() {
    var r = confirm("Confirm Item Delete");
    var _t = $(this);
    var _par = _t.parent().parent();
    if (r == true) {
      _par.remove();
    }


    // console.info('_par - ',_par);
    arrange_layers();
    update_fields({
      'call_from': 'layer_delete'
    });
  }

  function click_save_skin() {

    var mainarray = $('form[name="builder-form"]').serialize();
//        console.info(mainarray);


    if (window.ajaxurl) {

    } else {
      window.ajaxurl = 'builder.php';
    }
    var data = {
      action: 'dzsprg_saveskin'
      , postdata: mainarray
      , currSkin: dzsprg_builder_settings.currSkin
    };

    $('.saveconfirmer').html('Saving...');
    $('.saveconfirmer').addClass('active');
//        return false;
    $.post(window.ajaxurl, data, function (response) {
      if (window.console != undefined) {
        console.log('Got this from the server: ' + response);
      }


      response = parse_response(response);
      show_notice(response);

      setTimeout(function () {

        $('.saveconfirmer').removeClass('active');
      }, 2000);
    });
    return false;
  }

  function parse_response(response) {

    var arg = {};
    try {
      arg = JSON.parse(response);


    } catch (err) {
      console.log('did not parse', response);
    }

    return arg;
  }

  function show_notice(response) {


    if (typeof response == 'object') {
      if (response.report == 'success') {

        _feedbacker.removeClass('is-error');
        _feedbacker.html(response.text);
        _feedbacker.fadeIn('fast');

        setTimeout(function () {

          _feedbacker.fadeOut('slow');
        }, 1500)
      }
      if (response.report == 'error') {

        _feedbacker.addClass('is-error');
        _feedbacker.html(response.text);
        _feedbacker.fadeIn('fast');

        setTimeout(function () {

          _feedbacker.fadeOut('slow');
        }, 1500)
      }
    } else {
      if (response.indexOf('error -') == 0) {
        _feedbacker.addClass('is-error');
        _feedbacker.html(response.substr(7));
        _feedbacker.fadeIn('fast');

        setTimeout(function () {

          _feedbacker.fadeOut('slow');
        }, 1500)
      }
      if (response.indexOf('success -') == 0) {
        _feedbacker.removeClass('is-error');
        _feedbacker.html(response.substr(9));
        _feedbacker.fadeIn('fast');

        setTimeout(function () {

          _feedbacker.fadeOut('slow');
        }, 1500)
      }
    }


  }

  function change_skin_name() {
    var _t = $(this);

    if ($('form#create-custom-skin').attr('action')) {
      $('form#create-custom-skin').attr('action', $('form#create-custom-skin').attr('action') + '&skin=' + _t.val());
    } else {

      $('form#create-custom-skin').attr('action', 'builder.php?skin=' + _t.val());
    }
  }

  function click_add_btn(e) {
//        console.info(_areaCanvas);
    var _t = $(this);

    var _areaLayers_lars = _areaLayers.find('.dd > .dd-list').eq(0);

    if (_t.hasClass('builder-add-rect')) {
      _areaLayers_lars.append('' + dzsprg_builder_settings.struct_layer + '');
    }
    if (_t.hasClass('builder-add-text')) {
      _areaLayers_lars.append('' + dzsprg_builder_settings.struct_layer_text + '');
      //_areaLayers_lars.children().last().find('.the-title').html('text');
      _areaLayers_lars.children().last().find('input[name*="[text]"]').html('text');
      _areaLayers_lars.children().last().removeClass('type-rect').addClass('type-text');

      var _c = _areaLayers.children().last().find('textarea.with-tinymce');
      if (_c.hasClass('activated') == false) {

        _areaLayers_lars.children().last().find('textarea.with-tinymce').addClass('activated').tinymce(tinymce_settings);
      }
    }
    if (_t.hasClass('builder-add-circ')) {
      _areaLayers_lars.append('' + dzsprg_builder_settings.struct_layer_circ + '');
    }
    if (_t.hasClass('builder-add-container')) {
      _areaLayers_lars.append('' + dzsprg_builder_settings.struct_layer_container + '');
    }
    if (_t.hasClass('builder-add-repeater')) {
      _areaLayers_lars.append('' + dzsprg_builder_settings.struct_layer_repeater + '');
    }

    init_dzstabsandaccordions();
    reskin_select();
    arrange_layers();
    update_fields({
      'call_from': 'add_btn'
    });

    setTimeout(function () {

      dzstoggle_initalltoggles()
    }, 100)


  }

  function click_show_select() {
    var _t = $(this);
    var _par = _t.parent();

    _par.toggleClass('active');
    $('.super-select--options').eq(0)[0].reinit();
  }

  function change_builder_field() {
    var _t = $(this);
    var _t_name = _t.attr('name');


    var sw_arrange_layers = false; // restart everything

    if (_t_name) {

      if (_t_name.indexOf('[top]') > -1) {
        if (_t.val() != 'auto') {
          _t.parent().parent().parent().find('input[name*="[bottom]"]').eq(0).val('auto');
        }
      }
      if (_t_name.indexOf('[bottom]') > -1) {
        if (_t.val() != 'auto') {
          _t.parent().parent().parent().find('input[name*="[top]"]').eq(0).val('auto');
        }
      }
      if (_t_name.indexOf('[left]') > -1) {
        if (_t.val() != 'auto') {
          _t.parent().parent().parent().find('input[name*="[right]"]').eq(0).val('auto');
        }
      }
      if (_t_name.indexOf('[right]') > -1) {
        if (_t.val() != 'auto') {
          _t.parent().parent().parent().find('input[name*="[left]"]').eq(0).val('auto');
        }
      }


      if (_t.attr('data-label')) {
        sw_arrange_layers = true;
      }

    }
    if (sw_arrange_layers) {

      arrange_layers();
    }
    update_fields({
      'call_from': 'change_builder_field'
    });

    if (sw_arrange_layers) {
      setTimeout(function () {

        // arrange_layers();
      }, 100);
    }


  }

  function update_fields(pargs) {
    /*
     @here we set attributes for each layers
     */

    var margs = {

      'call_from': 'default'
    };

    if (pargs) {
      margs = $.extend(margs, pargs);
    }

    // console.info(margs);
    // console.info('update_fields()',margs );
    var i3 = 0;
    _areaLayers.find('.builder-layer').each(function () {
      var _t = $(this);
      var ind = _areaLayers.find('.builder-layer').index(_t);
      var _ite = $('#pbi-frombuilder-' + ind);

      _ite.attr('data-index', ind);

      _t.attr('id', 'bf' + i3);
      _t.attr('data-index', '' + i3);


      //console.info('_areaCanvas - ',_areaCanvas,_areaCanvas.children(),_areaCanvas.children().length);
      // console.info('_ite .builder-layer - ',_ite, ' ind - ',ind, ' _t - ',_t);

//            console.info(_t);
      _t.find('> .builder-layer--inside .builder-field').each(function () {
        var _t_bf = $(this); // -- builder field


        //console.info(_t_bf);
        var props_obj = {};
        if (_ite.attr('data-animprops')) {
          props_obj = JSON.parse(_ite.attr('data-animprops'));
        }

        // hmm maybe by knowing default values. <-- TODO: maybe reduce the attributes save
        if (_t_bf.attr('name')) {
          var arr_labels = ['width', 'height', 'top', 'left', 'bottom', 'right', 'margin_top', 'margin_left', 'margin_bottom', 'margin_right', 'padding_top', 'padding_left', 'padding_bottom', 'padding_right', 'border_radius', 'border', 'opacity', 'font_size', 'color', 'extra_classes', 'extra_attr', 'background_color', 'background_image', 'overflow'];

          for (var i = 0; i < arr_labels.length; i++) {

            if (String(_t_bf.attr('name').indexOf('[' + arr_labels[i] + ']')) > -1) {

              var aux = arr_labels[i];
              var val = _t_bf.val();

              // console.info(aux,' - ',val,_t_bf.attr('data-default-val'), _t_bf);

              if (val) {

                if (_t_bf.attr('data-default-val') && _t_bf.attr('data-default-val') == val) {
                  continue;
                }
              } else {
                continue;
              }

              if ((aux == 'top' || aux == 'right' || aux == 'bottom' || aux == 'left' || aux == 'width' || aux == 'height') && val.indexOf('%') == -1 && val.indexOf('px') == -1 && val != 'auto') {
                val += 'px';
              }
              if ((aux == 'padding_top' || aux == 'padding_right' || aux == 'padding_bottom' || aux == 'padding_left' || aux == 'margin_top' || aux == 'margin_right' || aux == 'margin_bottom' || aux == 'margin_left' || aux == 'border_radius' || aux == 'font_size' || aux == 'background_color' || aux == 'background_image')) {

                aux = aux.replace('_', '-');
              }

              if ((aux == 'margin-top' || aux == 'margin-right' || aux == 'margin-bottom' || aux == 'margin-left' || aux == 'padding-top' || aux == 'padding-right' || aux == 'padding-bottom' || aux == 'padding-left' || aux == 'border-radius' || aux == 'font-size')) {

                if (val.indexOf('%') == -1 && val.indexOf('px') == -1 && val != 'auto' && val.indexOf('{{') != 0) {

                  val += 'px';
                }
              }


              if (String(val).indexOf('{{arg') > -1) {

                // console.info('aux - ',aux);
                // console.info('val - ',val);
                var regex_getdef = new RegExp("{{arg(.)-default(.*?)}}");
                var auxa = regex_getdef.exec(String(val));
                if (auxa) {
                  if (auxa[2]) {
                    val = (auxa[2]);
                  }
                }


                // console.info('auxa - ',auxa);
//                    console.info(regex_getdef, auxa, cthis_animprops,auxa[2])
              } else {

              }


              if (aux == 'left') {
                //console.info(_t_bf, val);
              }

              //console.info('aux - ',aux,' val - ',val);
              if (aux == 'top') {
                if (val == '{{center}}' || val == '{{center}}px') {


                  _ite.addClass('center-it-v');
                  val = '';
                }
              }
              if (aux == 'extra_classes') {
                _ite.addClass(val);
              }
              if (aux == 'background-image') {
                val = 'url(' + val + ')';
              }

              //console.info('label - ', aux, ' || val - ',val);


              var is_css_value = false;


              if (val.indexOf('{{') == -1 && (aux == 'background-color' && val.indexOf('.') > -1) == false) {
                is_css_value = true;
              }

              if (is_css_value) {

                // console.info(' yes it is css value - ',aux, ' - ',val);
                _ite.css(aux, val);
                if (props_obj) {

                  if (props_obj.hasOwnProperty(aux)) {
                    delete props_obj[aux];
                  }
                }

              } else {
                _ite.css(aux, '');

                if (aux == 'background-color') {

                }
//                                console.info(_ite.attr('animprops'));


                //console.info(_t_bf, _t_bf.val(), _ite);
                props_obj[aux] = _t_bf.val();


              }


              if (aux == 'extra_attr') {


                if (val && _ite.get(0)) {

                  // console.info('_ite html - ',_ite.get(0).outerHTML);


                  var str = _ite.get(0).outerHTML;

                  _ite.get(0).outerHTML = str.replace('>', val + '>');
                }

              }

            }
          }
          var arr_labels_circ = ['circle_outside_fill', 'circle_inside_fill', 'circle_outer_width', 'circle_line_width'];
          if (_t.hasClass('type-circ')) {

            for (var j = 0; j < arr_labels_circ.length; j++) {

              if (String(_t_bf.attr('name').indexOf('[' + arr_labels_circ[j] + ']')) > -1) {

                var aux = arr_labels_circ[j];
                var val = _t_bf.val();

                props_obj[aux] = _t_bf.val();
              }
            }
          }
          if (String(_t_bf.attr('name').indexOf('[text_align]')) > -1) {
            _ite.css({
              'text-align': _t_bf.val()
            })

          }
          if (String(_t_bf.attr('name').indexOf('[position_type]')) > -1) {

            _ite.css({
              'position': _t_bf.val()
            })

          }
          if (String(_t_bf.attr('name').indexOf('[flex_mode]')) > -1) {

            if (_t_bf.val() == 'flex') {

              _ite.css({
                'display': 'flex'
                , 'align-items': 'center'
              })
            }

          }
          if (String(_t_bf.attr('name').indexOf('[flex_stretch]')) > -1) {

            if (_t_bf.val() && _t_bf.val() != 'none') {

              if (_t_bf.val() == '1000') {

                _ite.css({
                  'flex-grow': '1000'
                  , 'width': '100%'
                })
              }

              if (_t_bf.val() == '0 0 auto') {

                _ite.css({
                  'flex': '0 0 auto'
                  , 'width': 'auto'
                })
              }
            }

          }


          // console.info('_t_bf.attr(\'name\') - ',_t_bf.attr('name'), _ite);

          // -- text element
          if (_t_bf.hasClass('with-tinymce') && _t_bf.hasClass('activated')) {
//                        console.info(_t_bf, _t_bf.tinymce());
            if (_t_bf.tinymce() == null) {
              setTimeout(function (argind, arg_t) {
//                                console.info(argind, arg_t);
                if (arg_t.tinymce() != null) {
                  var aux = '';


                  if (arg_t.tinymce()) {

                    try {

                      console.log('arg_t.tinymce() - ', arg_t.tinymce());
                      aux = arg_t.tinymce().getContent({format: 'raw'});
                    } catch (err) {
                      console.log('tried to get content but failed :P ', err);
                    }
                  }
                  _ite.html(aux);
                  //-- " conflicts with JSON stringify so lets remove dat
                  aux = aux.replace(/"/g, "");
//                                    props_obj['text'] = aux;
                }
              }, 300, ind, _t_bf)
            } else {

              var aux = '';


              //console.warn('_t_bf - ',_t_bf,_t_bf.tinymce());
              if (_t_bf.tinymce() && _t_bf.tinymce().getContent) {

                try {

                  console.log('_t_bf.tinymce() - ', _t_bf, _t_bf.tinymce(), _t_bf.tinymce().getContent);
                  aux = _t_bf.tinymce().getContent({format: 'raw'});
                } catch (err) {
                  console.log(err);
                }
              }
              _ite.html(aux);
              //-- " conflicts with JSON stringify so lets remove dat
              aux = aux.replace(/"/g, "");
//                            props_obj['text'] = aux;
            }
//

          }

          if (String(_t_bf.attr('name').indexOf('[background_color]')) > -1) {

            //console.info('trying to set background-color - ',_areaCanvas.children().eq(ind), _t_bf.val());

            var bg_color = _t_bf.val();

            if (String(bg_color).indexOf(',') > -1) {
              _ite.attr('data-gradient-background', bg_color)
            } else {

              if (String(bg_color).indexOf('.') > -1) {
              } else {

                _ite.css({
                  'background-color': bg_color
                })
              }
            }


          }

          //console.info(props_obj,'_ite - ',_ite);
          _ite.attr('data-animprops', JSON.stringify(props_obj));
        }
      })

      i3++;
    })


    var aux = '';
    aux += '&lt;div class="dzs-progress-bar auto-init skin-' + dzsprg_builder_settings.currSkin + '" style="';

    var arr_labels = ['width', 'height', 'margin_top', 'margin_left', 'margin_bottom', 'margin_right', 'max_width'];

//        console.info($('input[name*="bars[mainsettings]"]'));
    $('input[name*="bars[mainsettings]"]').each(function () {
      var _t2 = $(this);

//            console.info(_t2, aux);
      for (var i = 0; i < arr_labels.length; i++) {

        //console.info('i - ',i, arr_labels[i], '_t2 - ',_t2, String(_t2.attr('name').indexOf('[' + arr_labels[i] + ']')))

        if (String(_t2.attr('name').indexOf('[' + arr_labels[i] + ']')) > -1) {

          var aux_lab = arr_labels[i];
          var val = _t2.val();

          if ((aux_lab == 'margin_top' || aux_lab == 'margin_right' || aux_lab == 'margin_bottom' || aux_lab == 'margin_left' || aux_lab == 'max_width')) {

            aux_lab = aux_lab.replace('_', '-');
            if (val.indexOf('%') == -1 && val != 'auto') {

              val += 'px';
            }
          }
          aux += '' + aux_lab + ':' + val + ';';
          //console.info('found _t2 - ',_t2,'i - ',i, arr_labels[i] , aux_lab, aux);
        }
      }
    })
    aux += '"';


    // for maincon
    aux += ' data-animprops=\'{';

    var auxlab = 'animation_time';
    var firstset = false;
    if ($('input[name*="bars[mainsettings][' + auxlab + ']"]').length > 0 && $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() != '') {
      aux += '"' + auxlab + '":"' + $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() + '"';
      firstset = true;
    }

    auxlab = 'maxperc';
    if ($('input[name*="bars[mainsettings][' + auxlab + ']"]').length > 0 && $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() != '') {
      if (firstset) {
        aux += ',';
      }

      aux += '"' + auxlab + '":"' + $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() + '"';
      firstset = true;
    }
    auxlab = 'maxnr';
    if ($('input[name*="bars[mainsettings][' + auxlab + ']"]').length > 0 && $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() != '') {
      if (firstset) {
        aux += ',';
      }

      aux += '"' + auxlab + '":"' + $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() + '"';
      firstset = true;
    }
    auxlab = 'initon';
    if ($('select[name*="bars[mainsettings][' + auxlab + ']"]').length > 0 && $('select[name*="bars[mainsettings][' + auxlab + ']"]').val() != '') {
      if (firstset) {
        aux += ',';
      }

      aux += '"' + auxlab + '":"' + $('select[name*="bars[mainsettings][' + auxlab + ']"]').val() + '"';
      firstset = true;
    }


    aux += '}\''
    aux += ' data-options=\'{';

    var auxlab = 'text_transition';
    firstset = false;
    if ($('select[name*="bars[mainsettings][' + auxlab + ']"]').length > 0 && $('select[name*="bars[mainsettings][' + auxlab + ']"]').val() != '') {
      aux += '"' + auxlab + '":"' + $('input[name*="bars[mainsettings][' + auxlab + ']"]').val() + '"';
      firstset = true;
    }


    aux += '}\''

    aux += '&gt;';

    var aux_items = htmlEncode(_areaCanvas.html());
//        console.info(aux_items);

    // -- sanitizing
    aux_items = aux_items.replace(/id="(.*?)" /g, " ");
    aux_items = aux_items.replace(/data-mce-style="(.*?)"/g, "");
    aux_items = aux_items.replace(/data-animprops="(.*?)" /g, "data-animprops='$1' ");
    aux_items = aux_items.replace(/&amp;quot;/g, '"');
    aux_items = aux_items.replace(/url\("(.*?)"\)/g, 'url($1)');


//        console.info(aux_items);
    aux += aux_items;
    aux += '&lt;/div&gt;';


    // -- update_to_ce()
    $('.dzsprg-output-div').html(aux);


    if (inter_update_preview) {
      clearTimeout(inter_update_preview);
    }

    inter_update_preview = setTimeout(update_preview, 100);
  }

  function update_preview() {

    click_preview();
  }

  function init_dzstabsandaccordions() {

    _areaLayers.children().find('.dzs-tabs').dzstabsandaccordions({
      'design_tabsposition': 'top'
      , design_transition: 'fade'
      , design_tabswidth: 'fullwidth'
      , toggle_breakpoint: '4000'
      , toggle_type: 'toggle'
      , refresh_tab_height: '1000'
      , settings_appendWholeContent: true
    });

    reskin_select();
    window.farbtastic_reinit();


    $(".jqueryui-slider.for-fontsize").slider({
      range: "max",
      min: 11,
      max: 72,
      value: 24,
      slide: function (e, ui) {
//            $( "#amount" ).val( ui.value );
        var _t = $(this);
        var _par = _t.parent();
        _par.find('input').eq(0).val(ui.value);
        _par.find('input').eq(0).trigger('change');
      }
    });
  }

  function sanitize_dim_css(arg) {


    if (arg.indexOf('px') > -1) {
      return arg;
    }
    if (arg.indexOf('%') > -1) {
      return arg;
    }
    if (arg.indexOf('auto') > -1) {
      return arg;
    }
    if (arg.indexOf('{{') > -1) {
      return arg;
    }

    return arg + 'px';

  }

  function arrange_layers() {
    /*

     @arrange layers, name inputs and build the main canvas area

     */

    console.log('arrange_layers', _areaCanvas);
    _areaCanvas.find('.dzs-progress-bars').each(function () {

      var _t = $(this);
      if (_t.get(0) && _t.get(0).api_destroy_listeners) {
        _t.get(0).api_destroy_listeners();
      }
    });
    _areaCanvas.children().remove();
    _areaCanvas.removeClass('started inited');

    var bl_index = 0;


    var _c = $('*[name="bars[mainsettings][max_width]"]').eq(0);

    if (_c.val()) {
      _areaCanvas.css({
        'max-width': _c.val() + 'px'
        , 'margin-left': 'auto'
        , 'margin-right': 'auto'
      })
    }
//        console.info(_areaLayers.children());
    var i3 = 0;
    for (var i = 0; i < _areaLayers.find('> .dd > .dd-list > .builder-layer').length; i++) {
      var _layer = _areaLayers.find('> .dd > .dd-list > .builder-layer').eq(i);

      _layer.find('textarea.with-tinymce').each(function () {
        var _t = $(this);
        if (_t.hasClass('activated') == false) {
          if ($.fn.tinymce) {
            _t.addClass('activated').tinymce(tinymce_settings);
          }
        }
      })


      // console.info('_layer prime - ',_layer, i);

      _layer.find('*[name^="bars["]').each(function () {
        var _t = $(this);
//                console.info(_t);

        var aux = _t.attr('name');

        aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]/g, "bars[" + i + "]");

        _t.attr('name', aux);
      });

//            console.info(_layer);

      var aux_type = _layer.find('.the-title').eq(0).attr('data-type');


      var aux_output = '';

      if (aux_type == 'circ') {
        aux_output += '<canvas id="pbi-frombuilder-' + (bl_index++) + '" class="progress-bar-item progress-bar-item--' + aux_type + '" data-type="' + aux_type + '"></canvas>';
      } else {
        if (aux_type == 'container') {
          aux_output += '<div id="pbi-frombuilder-' + (bl_index++) + '"  class="progress-bar-item progress-bar-item--' + aux_type + '" data-type="' + aux_type + '">';
        } else {

          if (aux_type == 'repeater') {


            // console.info('_layer - ',_layer);

            // font-size: 25px;


            var str_width = sanitize_dim_css(_layer.find('*[data-label="repeater_width"]').val());
            var str_height = sanitize_dim_css(_layer.find('*[data-label="repeater_height"]').val());
            var str_padding = sanitize_dim_css(_layer.find('*[data-label="repeater_padding"]').val());
            var str_font_size = sanitize_dim_css(_layer.find('*[data-label="repeater_font_size"]').val());

            aux_output += '<div id="pbi-frombuilder-' + (bl_index++) + '"  class="progress-bar-item progress-bar-item--' + aux_type + ' repeater-transition-' + _layer.find('*[data-label="repeater_item_transition"]').val() + '" data-type="' + aux_type + '"';


            aux_output += ' data-animprops=\'{"steps":"10","repeater_static_background_color":"' + _layer.find('*[data-label="repeater_static_background_color"]').val() + '","repeater_static_color":"' + _layer.find('*[data-label="repeater_static_color"]').val() + '","repeater_active_bg_color":"' + _layer.find('*[data-label="repeater_active_background_color"]').val() + '","repeater_active_color":"' + _layer.find('*[data-label="repeater_active_color"]').val() + '"}\'';

            aux_output += '>';


            aux_output += '<div class="repeater-item repeater-item--sample" style="width: ' + (100 / Number(_layer.find('*[data-label="number_of_items"]').val())) + '%;';


            // console.warn('str_padding - ',str_padding);
            if (str_padding) {
              aux_output += 'padding: ' + str_padding + ';';
            }


            aux_output += '"><div class="repeater-item--inner"><i class="progress-icon-con dims-set';

            if (str_height == '{{width}}') {
              aux_output += ' height-same-as-width';
            }

            aux_output += '" style="background-color: ' + _layer.find('*[data-label="repeater_static_background_color"]').val() + '; color: ' + _layer.find('*[data-label="repeater_static_color"]').val() + '; padding: 0px; width: ' + str_width + '; height: ' + str_height + ';';

            aux_output += ' font-size: ' + str_font_size + ';';


            aux_output += '">';

            aux_output += '<i class="real-icon fa fa-' + _layer.find('*[data-label="item_icon"]').val() + '" style=""></i></i></div></div>';


            aux_output += '</div>';

            // console.info('aux_output - ', aux_output);
          } else {

            aux_output += '<div id="pbi-frombuilder-' + (bl_index++) + '"  class="progress-bar-item progress-bar-item--' + aux_type + '" data-type="' + aux_type + '"></div>';
          }
        }
      }


      if (aux_type == 'container') {

        for (var j = 0; j < _layer.find('.dd-list > .builder-layer').length; j++) {
          var _layerkid = _layer.find('.dd-list > .builder-layer').eq(j);

          _layerkid.find('textarea.with-tinymce').each(function () {
            var _t = $(this);
            if (_t.hasClass('activated') == false) {
              if ($.fn.tinymce) {
                _t.addClass('activated').tinymce(tinymce_settings);
              }
            }
          })


          // console.info('_layerkid - ',_layerkid, j);

          _layerkid.find('*[name^="bars["]').each(function () {
            var _t = $(this);
//                console.info(_t);

            var aux = _t.attr('name');


            aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[(0|[1-9][0-9]*)\]\[([a-z])/g, "bars[" + i + "][" + j + "][$3");
            aux = aux.replace(/bars\[(0|[1-9][0-9]*)\]\[([a-z].*)\]/g, "bars[" + i + "][" + j + "][$2]");

            _t.attr('name', aux);
          })

//            console.info(_layerkid);

          var aux_type = _layerkid.find('.the-title').eq(0).attr('data-type');

          if (aux_type == 'circ') {
            aux_output += '<canvas id="pbi-frombuilder-' + (bl_index++) + '" class="progress-bar-item progress-bar-item--' + aux_type + '" data-type="' + aux_type + '"></canvas>'
          } else {


            if (aux_type == 'repeater') {


              //font-size: 25px;
              // console.info('_layer - ',_layer);


              var str_width = sanitize_dim_css(_layer.find('*[data-label="repeater_width"]').val());
              var str_height = sanitize_dim_css(_layer.find('*[data-label="repeater_height"]').val());
              var str_padding = sanitize_dim_css(_layer.find('*[data-label="repeater_padding"]').val());
              var str_font_size = sanitize_dim_css(_layer.find('*[data-label="repeater_font_size"]').val());

              aux_output += '<div id="pbi-frombuilder-' + (bl_index++) + '"  class="progress-bar-item progress-bar-item--' + aux_type + ' repeater-transition-' + _layer.find('*[data-label="repeater_item_transition"]').val() + '" data-type="' + aux_type + '"';


              aux_output += ' data-animprops=\'{"steps":"10","repeater_active_color":"' + _layer.find('*[data-label="repeater_active_color"]').val() + '","repeater_active_bg_color":"' + _layer.find('*[data-label="repeater_active_background_color"]').val() + '"}\'';

              aux_output += '><div class="repeater-item repeater-item--sample" style="width: 10%;';


              // console.warn('str_padding - ',str_padding);
              if (str_padding) {
                aux_output += 'padding: ' + str_padding + ';';
              }


              aux_output += '"><div class="repeater-item--inner"><i class="progress-icon-con dims-set';

              if (str_height == '{{width}}') {
                aux_output += ' height-same-as-width';
              }

              aux_output += '" style="background-color: ' + _layer.find('*[data-label="repeater_static_background_color"]').val() + '; color: ' + _layer.find('*[data-label="repeater_static_color"]').val() + '; padding: 0px; width: ' + str_width + '; height: ' + str_height + ';';

              aux_output += ' font-size: ' + str_font_size + ';';


              aux_output += '"><i class="real-icon fa fa-' + _layer.find('*[data-label="item_icon"]').val() + '" style=""></i></i></div></div></div>';


            } else {

              aux_output += '<div id="pbi-frombuilder-' + (bl_index++) + '"  class="progress-bar-item progress-bar-item--' + aux_type + '" data-type="' + aux_type + '"></div>';
            }

            // aux_output += '<div id="pbi-frombuilder-'+(bl_index++)+'"  class="progress-bar-item pbi-from-else progress-bar-item--'+aux_type+'" data-type="'+aux_type+'"></div>';
          }


          if (aux_type == 'container') {

          }

        }
      }


      if (aux_type == 'circ') {
      } else {
        if (aux_type == 'container') {
          aux_output += '</div>';
        } else {

        }
      }


      console.warn('aux_output - ', aux_output);
      _areaCanvas.append(aux_output);


    }


//        console.info($('.dzsprg-output-con'), String(htmlEncode(_areaCanvas.html())));
  }

  function htmlEncode(value) {
    //create a in-memory div, set it's inner text(which jQuery automatically encodes)
    //then grab the encoded contents back out.  The div never exists on the page.
    return $('<div/>').text(value).html();
  }

  function htmlDecode(value) {
    return $('<div/>').html(value).text();
  }

  function handle_scroll(e) {

    var st = $(window).scrollTop();

    var _cache = $('.main-col-for-canvas');

    // console.info(st, _cache.offset().top);


    if (initial_cache_offset_top == -1) {
      initial_cache_offset_top = _cache.offset().top;
    }

    var auxt = st - initial_cache_offset_top + 10;


    _cache.css('top', '0');

    if (auxt + initial_cache_offset_top > $('#tabs-mainsettings').offset().top - _cache.outerHeight() - 10) {


      auxt = $('#tabs-mainsettings').offset().top - _cache.outerHeight() - initial_cache_offset_top - 10;
      console.warn('hitlimit', $('#tabs-mainsettings').offset().top, _cache.outerHeight(), initial_cache_offset_top, auxt);
    }

    if (st > initial_cache_offset_top) {

    } else {
      auxt = 0;
    }


    _cache.css('top', auxt);

  }

  function handle_mouse(e) {
    var _t = $(this);

    if (e.type == 'mouseover') {
      if (_t.hasClass('builder-layer')) {
        //console.info('mouseover');


        var aux = '#pbi-frombuilder-' + _t.attr('data-index');
        //console.info(aux);
        $(aux).addClass('hovered');
      }
    }
    if (e.type == 'mouseleave') {

      if (_t.hasClass('builder-layer')) {
        $('.progress-bar-item').removeClass('hovered');
        if (_t.hasClass('builder-layer--head')) {
          console.info('mouseleave');
        }
      }
    }
    if (e.type == 'click') {

      if (_t.hasClass('btn-insert-icon')) {
        var _con = _t.parent();
        var _conpar = _t.parent().parent().parent();


        var val = _con.find('.iconselector-waiter').eq(0).val();

        var tid = _conpar.find('.with-tinymce').eq(0).attr('id');
        var ed = tinyMCE.get(tid);

        if (ed) {
          var data2 = ed.getContent({format: "raw"});

          console.info(data2);

          if (data2.indexOf('</div>') > -1) {

            data2 = data2.replace(new RegExp('<\/div>$'), '<i class="fa fa-' + val + '"></i></div>');
          } else {
            data2 += '<i class="fa fa-' + val + '"></i>';
          }

          ed.setContent(data2, {format: 'raw'});
          _conpar.find('.with-tinymce').trigger('change');

          setTimeout(function () {
            console.log('content - ', ed.getContent({format: 'raw'}));
          }, 1000)
        }
        console.warn(val, _conpar.find('.with-tinymce').eq(0), _conpar.find('.with-tinymce').eq(0).attr('id'));


        return false;
      }
      if (_t.hasClass('btn-skin-settings')) {
        _t.find('.dzstooltip').toggleClass('active');

      }
      if (_t.hasClass('delete-skin-btn')) {

        var _con = _t.parent().parent();

        console.info("CEVA");
        var mainarray = $('form[name="builder-form"]').serialize();
//        console.info(mainarray);


        if (window.ajaxurl) {

        } else {
          window.ajaxurl = 'builder.php';
        }
        var data = {
          action: 'dzsprg_ajax_delete_skin'
          , postdata: _con.attr('data-skin')
          , nonce: _t.attr('data-nonce')
        };

        $('.saveconfirmer').html('Saving...');
        $('.saveconfirmer').addClass('active');
//        return false;
        $.post(window.ajaxurl, data, function (response) {
          if (window.console != undefined) {
            console.log('Got this from the server: ' + response);
          }


          response = parse_response(response);
          show_notice(response);

          setTimeout(function () {

            $('.saveconfirmer').removeClass('active');
          }, 2000);


          console.info(response);


          if (response.report == 'success') {
            // $('.saveconfirmer').html('Options saved.');

            _con.remove();

            setTimeout(function () {

              if (_con.parent().parent().hasClass('zfolio')) {

                console.warn("HANDLE RESIZE", _con.parent().parent().get(0), _con.parent().parent().get(0).api_handle_resize)
                _con.parent().parent().get(0).api_handle_resize();
              }
            }, 500)
          } else {

            // $('.saveconfirmer').html('Seems there was a error saving....');
          }
          setTimeout(function () {

            $('.saveconfirmer').removeClass('active');
          }, 2000);
        });
        return false;
      }


      if (_t.hasClass('dzs-button-on-off')) {

        if (_t.hasClass('active')) {


          var _ca = $('.skins-first-models').eq(0);
          var _cn = $('.skins-all-models').eq(0);

          _ca.css('height', 'auto');
          _ca.css('display', 'block');

          var auxh = _ca.height();
          var auxbh = _cn.height();

          _ca.css('height', '0');
          _cn.css('height', auxbh);

          setTimeout(function () {
            _ca.css('height', auxh);
            _cn.css('height', 0);

          }, 50)

          setTimeout(function () {
            _ca.css('height', 'auto');
            _cn.css('display', 'none');

          }, 450)

          _ca.removeClass('nonactive').addClass('active');
          _cn.removeClass('active').addClass('nonactive');


          _t.removeClass('active');


        } else {

          var _ca = $('.skins-all-models').eq(0);
          var _cn = $('.skins-first-models').eq(0);

          _ca.css('height', 'auto');
          _ca.css('display', 'block');

          var auxh = _ca.height();
          var auxbh = _cn.height();

          _ca.css('height', '0');
          _cn.css('height', auxbh);

          setTimeout(function () {
            _ca.css('height', auxh);
            _cn.css('height', 0);


          }, 50)

          setTimeout(function () {
          }, 250)

          setTimeout(function () {
            _ca.css('height', 'auto');
            _cn.css('display', 'none');

            dzszfl_init(_ca.find('.zfolio').eq(0), {init_each: true});
            dzsprb_init(_ca.find('.zfolio .dzs-progress-bar'), {init_each: true});

            setTimeout(function () {
              _ca.find('.zfolio').eq(0).get(0).api_handle_resize();
            }, 100);
          }, 450)

          _ca.removeClass('nonactive').addClass('active');
          _cn.removeClass('active').addClass('nonactive');


          _t.addClass('active');
        }
      }
    }
  }

  function click_layer_head(e) {
    var _t = $(this);

    if (_t.find('.sortable-handle-con').has($(e.target)).length > 0) {
      return;
    }
    _t.parent().toggleClass('active');
  }

  function reskin_select() {
    $(document).undelegate(".select-wrapper select", "change");
    $(document).delegate(".select-wrapper select", "change", change_select);

//        console.info($('select'));
    $('select.styleme').each(function () {

      var _cache = $(this);
//            console.log(_cache);

      if (_cache.parent().hasClass('select_wrapper') || _cache.parent().hasClass('select-wrapper')) {
        return;
      }
      var sel = (_cache.find(':selected'));
//            console.info(sel, _cache.val());
      _cache.wrap('<div class="select-wrapper"></div>')
      _cache.parent().prepend('<span>' + sel.text() + '</span>');
      _cache.trigger('change');
    })


    function change_select() {
      var selval = ($(this).find(':selected').text());
      $(this).parent().children('span').text(selval);
    }

  }
});


/* @projectDescription jQuery Serialize Anything - Serialize anything (and not just forms!)
 * @author Bramus! (Bram Van Damme)
 * @version 1.0
 * @website: http://www.bram.us/
 * @license : BSD
 */

(function ($) {

  $.fn.serializeAnything = function () {

    var toReturn = [];
    var els = $(this).find(':input').get();

    $.each(els, function () {
      if (this.name && !this.disabled && (this.checked || /select|textarea/i.test(this.nodeName) || /text|hidden|password/i.test(this.type))) {
        var val = $(this).val();
        toReturn.push(encodeURIComponent(this.name) + "=" + encodeURIComponent(val));
      }
    });

    return toReturn.join("&").replace(/%20/g, "+");

  }

})(jQuery);