<?php

if(function_exists('vc_map')){
    vc_map(array(
        "name" => __("Zoom Progress Bar"),
        "base" => "dzsprogressbar",
        "class" => "",
        "js_view" => 'ProgressBarsSelector',
        "admin_enqueue_js" => $this->base_url.'vc/backbone.js',
        "front_enqueue_js" => $this->theurl.'js/frontend_backbone.js',
        "category" => __('Content'),
        "params" => array(
            array(
                'type' => 'dropdown',
                'heading' => __('Skin'),
                'param_name' => 'skin',
                'admin_label' => true,
                'value' => $arr_skins,
                'description' => __('Select a skin from the one\'s you built in the generator.')
            ),
            array(
                "type" => "textfield",
//                "holder" => "div",
                "class" => "",
                "heading" => __("Percent"),
                "param_name" => "arg1_perc",
                "value" => '80',
                "description" => __("The percent on which the progress bar goes. A value from 0 to 100.")
            ),
            array(
                "type" => "textfield",
//                "holder" => "div",
                "class" => "",
                "heading" => __("Percent Number"),
                "param_name" => "arg2_maxnr",
                "value" => '80',
                "description" => __("A number that can be increased based on percent. Can be any number.")
            ),
            array(
                "type" => "textarea_html",
                "holder" => "div",
                "class" => "",
                "heading" => __("Text"),
                "param_name" => "content",
                "value" => __("<p>I am test text block. Click edit button to change this text.</p>"),
                "description" => __("Enter your text for skins that receive a text parameter.")
            ),


            array(
                "type" => "textfield",
                "holder" => "div",
                "class" => "",
                "heading" => sprintf(__("Argument %s"),'4'),
                "param_name" => "arg4",
                "edit_field_class" => "forcecol4",
                "value" => '',
                "description" => __("Fourth"). ' '. __("parameter").' - '.__("if your skin has support for it")
            ),


            array(
                "type" => "textfield",
                "holder" => "div",
                "class" => "",
                "heading" => sprintf(__("Argument %s"),'5'),
                "param_name" => "arg5",
                "edit_field_class" => "forcecol4",
                "value" => '',
                "description" => __("Fifth"). ' '. __("parameter").' - '.__("if your skin has support for it")
            ),


            array(
                "type" => "textfield",
                "holder" => "div",
                "class" => "",
                "heading" => sprintf(__("Argument %s"),'6'),
                "param_name" => "arg6",
                "edit_field_class" => "forcecol4",
                "value" => '',
                "description" => __("Sixth"). ' '. __("parameter").' - '.__("if your skin has support for it")
            ),




            array(
                "type" => "textfield",
                "holder" => "div",
                "class" => "",
                "heading" => sprintf(__("Argument %s"),'7'),
                "param_name" => "arg7",
                "edit_field_class" => "forcecol4",
                "value" => '',
                "description" => __("Seventh"). ' '. __("parameter").' - '.__("if your skin has support for it")
            ),


            array(
                "type" => "textfield",
                "holder" => "div",
                "class" => "",
                "heading" => sprintf(__("Argument %s"),'8'),
                "param_name" => "arg8",
                "edit_field_class" => "forcecol4",
                "value" => '',
                "description" => __("Eighth"). ' '. __("parameter").' - '.__("if your skin has support for it")
            ),


            array(
                "type" => "textfield",
                "holder" => "div",
                "class" => "",
                "heading" => sprintf(__("Argument %s"),'9'),
                "param_name" => "arg9",
                "edit_field_class" => "forcecol4",
                "value" => '',
                "description" => __("Nineth"). ' '. __("parameter").' - '.__("if your skin has support for it")
            ),





        )
    ));
}
