jQuery(document).ready(function ($) {


  if (window.dzsprg_builder_settings) {

    if (window.dzsprg_builder_settings.notice_builder === 'on') {


      var _c = $('#toplevel_page_dzsprg_builder').eq(0);


      setTimeout(function () {
        _c.find('.dzstooltip').addClass('active');
      }, 1000)

      _c.addClass('dzstooltip-con dzs-tooltip-notice dzsprg-notice dzsprg-notice--preview');
      _c.attr('data-lab', 'dzsprg_notice_builder');
      _c.append('<span style="left: 15px;" class="dzstooltip skin-whiteheading  arrow-top align-left"><strong>Progress Bars</strong>: build and preview skins from here. <i class="fa fa-times-circle close-notice"></i></span>')
    }

    let localStorage_dismissed_shortcode_builder_key = 'dzsprg_notice_dismissed_notice_shortcode_builder';
    if (!window.localStorage.getItem(localStorage_dismissed_shortcode_builder_key)) {


      const $shortcodeGenerator = $('#dzsprg-shortcode-generator').eq(0);


      setTimeout(function () {
        $shortcodeGenerator.find('.dzstooltip').addClass('active');
      }, 1000)

      $shortcodeGenerator.addClass('dzstooltip-con dzs-tooltip-notice dzsprg-notice dzsprg-notice--preview');
      $shortcodeGenerator.attr('data-lab', 'dzsprg_notice_shortcode_builder');
      $shortcodeGenerator.append('<span style="left: 15px;" class="dzstooltip skin-whiteheading  arrow-bottom align-left">You can insert progress bars from here. <i class="fa fa-times-circle close-notice" data-close-notice-key="' + localStorage_dismissed_shortcode_builder_key + '"></i></span>')
    }
  }


  $(document).delegate('.import-sample,.close-notice', 'click', handle_mouse);
  $(document).delegate('div[data-vc-shortcode="dzsprogressbar"] select[name="skin"]', 'change', handle_change);


  function process_edit_field(_cach, _con, label) {
    if (label) {


      _con.show();

      _con.find('.wpb_element_label').html(label);

    } else {

      _con.hide();
    }


  }

  function handle_change(e) {
    var _t = $(this);

    if (e.type === 'change') {
      console.info(_t);

      var val = _t.val();


      var data = {
        action: 'dzsprg_get_skin_data'
        , postdata: val
      };


      $.ajax({
        type: "POST",
        url: ajaxurl,
        data: data,
        success: function (response) {

          try {
            var skin_data = JSON.parse(response)


            console.log(skin_data);

            var _cach = null;

            _cach = $('input[name="arg4"]');

            var _con = _cach.parent().parent();


            process_edit_field(_cach, _con, skin_data.bars.mainsettings.arg4_label);

            _cach = $('input[name="arg5"]');
            _con = _cach.parent().parent();


            process_edit_field(_cach, _con, skin_data.bars.mainsettings.arg5_label);

            _cach = $('input[name="arg6"]');
            _con = _cach.parent().parent();


            process_edit_field(_cach, _con, skin_data.bars.mainsettings.arg6_label);


            _cach = $('input[name="arg7"]');
            _con = _cach.parent().parent();


            process_edit_field(_cach, _con, skin_data.bars.mainsettings.arg7_label);


            _cach = $('input[name="arg8"]');
            _con = _cach.parent().parent();


            process_edit_field(_cach, _con, skin_data.bars.mainsettings.arg8_label);


            _cach = $('input[name="arg9"]');
            _con = _cach.parent().parent();


            process_edit_field(_cach, _con, skin_data.bars.mainsettings.arg9_label);


          } catch (err) {
            console.info('no skin data ', response);
          }




        },
        error: function (arg) {
          if (typeof window.console != "undefined") {
            console.warn('Got this from the server: ' + arg);
          }
          ;
        }
      });

    }
  }


  function handle_mouse(e) {
    var _t = $(this);

    if (e.type === 'click') {

      if (_t.hasClass('close-notice')) {


        if (_t.attr('data-close-notice-key')) {

          localStorage.setItem(_t.attr('data-close-notice-key'), 'on');
        }
        if (_t.parent().parent().hasClass('dzs-tooltip-notice')) {
          const $dzsTooltipNoticeCon = _t.parent();


          $dzsTooltipNoticeCon.fadeOut('fast');
          var data = {
            action: 'dzs_delete_notice'
            , postdata: $dzsTooltipNoticeCon.parent().attr('data-lab')
          };


          jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            data: data,
            success: function (response) {


              $dzsTooltipNoticeCon.fadeOut('fast');


            },
            error: function (arg) {
              if (typeof window.console != "undefined") {
                console.warn('Got this from the server: ' + arg);
              }
              ;
            }
          });


        }
      }

    }
  }

})