



console && console.log('admin_enqueue_js.js is loaded');
// Come from vc_map -> 'js_view' => 'ProgressBarsSelector'
window.ProgressBarsSelector = vc.shortcode_view.extend({
    // Render method called after element is added( cloned ), and on first initialisation
    render: function () {
        console && console.log('ProgressBarsSelector: render method called.', this);
        window.ProgressBarsSelector.__super__.render.call(this); //make sure to call __super__. To execute logic fron inherited view. That way you can extend original logic. Otherwise, you will fully rewrite what VC will do at this event

        return this;
    },
    ready: function (e) {
        // console && console.log('ProgressBarsSelector: ready method called.');
        window.ProgressBarsSelector.__super__.ready.call(this, e);

        return this;
    },
    //Called every time when params is changed/appended. Also on first initialisation
    changeShortcodeParams: function (model) {
        console && console.log('ProgressBarsSelector: changeShortcodeParams method called.');
        // console && console.log(model.getParam('value') + ': this was maped in vc_map() "param_name"  => "value"');
        window.ProgressBarsSelector.__super__.changeShortcodeParams.call(this, model);


    },
    changeShortcodeParent: function (model) {
        // console && console.log('ProgressBarsSelector: changeShortcodeParent method called.');
        window.ProgressBarsSelector.__super__.changeShortcodeParent.call(this, model);
    },
    deleteShortcode: function (e) {
        // console && console.log('ProgressBarsSelector: deleteShortcode method called.');
        window.ProgressBarsSelector.__super__.deleteShortcode.call(this, e);
    },
    editElement: function (e) {
        // -- only edit matters
        console && console.log('ProgressBarsSelector: editElement method called.', this, e);
        window.ProgressBarsSelector.__super__.editElement.call(this, e);

        // console.info(this);


        setTimeout(function(){
            // console.info(jQuery('.iconselector .iconselector-waiter'))
            // jQuery('.iconselector .iconselector-waiter').trigger('change');
            jQuery('div[data-vc-shortcode="dzsprogressbar"] select[name="skin"]').trigger('change');
        },1000);
    },
    clone: function (e) {
        // console && console.log('ProgressBarsSelector: clone method called.');
        window.ProgressBarsSelector.__super__.clone.call(this, e);
    }
});


